;-----------------------------------------------------------------------------;
; `uqVA_E[hvO (COM|[gp)
;
;Date:     2000.08.02
;Revision: 0.11
;Authoer:  ChaN (T.Akamatsu)


include	stddef.inc
include	str.inc
include	file.inc
include	ibmpc.inc

;------------------------------------------------;
; [NGA

.model t
.data

;--------------------------------------;
; e탁bZ[W

MessStart	db	'AVRSS - AVR serial download tool for COM port. R0.11 (C)ChaN,2000.%n'
		db	'        Support: http://elm-chan.org/%n%n',0
MessNoCom	db	'No COM%ui port in this system.%n',0
MessUsage	db	'Write code, data         : avrss <hex file> [<hex file>] ...',CR,LF
		db	'Verify code, data        : avrss /v ...',CR,LF
		db	'Read code, data, fuse    : avrss /r',CR,LF
		db	'Chip erase               : avrss /e',CR,LF
		db	'Write fuse bits          : avrss /f<h>',CR,LF
		db	'Lock device              : avrss /l',CR,LF
		db	'Specify port number COMn : avrss /p<n> ...',CR,LF
		db	'Allow for slow clock     : avrss /s ...',CR,LF
		db	CR,LF,'$'
MessErHex	db	'Hex file error.',CR,LF,'$'
MessNoFuse	db	'This device has no fuse R/W capability on the serial downloading.',CR,LF,'$'
MessCodeP	db	'Flash: Writing...$'
MessDataP	db	'EEPROM: Writing...$'
MessVerify	db	'Verifying...$'
MessErrAdr	db	'error %h4:%h2-%h2%n',0
MessFuse	db	'Writing Fuse bits...$'
MessLock	db	'Writing Lock bits...$'
MessErase	db	'Chip Erasing...$'
MessPass	db	'OK'
CrLf		db	CR,LF,'$'
MessRead	db	'Reading...',0
MessPass2	db	'OK%n',0
MessCan2	db	'Canceled%n',0

ExtEep		db	'.EEP'
HeadCode	db	'[PROGRAM CODE]',CR,LF,'$'
HeadData	db	'[EEPROM DATA]',CR,LF,'$'
HeadFuse	db	'[FUSE DATA]',CR,LF,'$'
HeadCal		db	'[CAL. BYTE]',CR,LF,'$'

CodeMatch	db	'MARGORP'	; PROGRAM
DataMatch	db	'MORPEE'	; EEPROM

		; Program return codes
RC_PASS		equ	0	; Successful
RC_FAIL		equ	1	; Verify error
RC_FILE		equ	2	; File operation error
RC_DEV		equ	3	; Unknown device type
RC_ENV		equ	4	; Envilonment error
RC_SYNTAX	equ	5	; Command line syntax error


;--------------------------------------;
; foCX֌W

SIGN_2313	equ	0191h
SIGN_1200	equ	0190h
SIGN_2333	equ	0591h
SIGN_4433	equ	0392h
SIGN_4414	equ	0192h
SIGN_8515	equ	0193h
SIGN_4434	equ	0292h
SIGN_8535	equ	0393h
SIGN_2323	equ	0291h
SIGN_2343	equ	0391h
SIGN_T12	equ	0590h
SIGN_T22	equ	0691h
SIGN_T15	equ	0690h

DevList		db	'Supported Device:',CR,LF
		db	'2313,1200,2333,4433,4414,8515,4434,8535',CR,LF
		db	'2323,2343,tiny12,tiny15,tiny22',CR,LF
		db	'$'
NameDisp	db	'Detected device is AT%s%n%n',0
NameUnknown	db	'Device is not working or not supported device (%h2,%h2,%h2).%n'
		db	'%nATTENTION:%nAn RS-232C signal that be used as input has been changed.%nMake sure that your ISP cable is using DR signal as input, not RI.',0


NameLocked	db	'This device is locked.%n',0
S1200		db	'90S1200',0
S2313		db	'90S2313',0
S2333		db	'90S2333',0
S4414		db	'90S4414',0
S4433		db	'90S4433',0
S4434		db	'90S4434',0
S8515		db	'90S8515',0
S8535		db	'90S8535',0
S2323		db	'90S2323',0
S2343		db	'90S2343',0
T12		db	'tiny12',0
T22		db	'tiny22',0
T15		db	'tiny15',0


CodeSize	dw	0	; Loaded program code size
DataSize	dw	0	; Loaded eeprom data size
FlashSize	dw	?	; Size of program rom
EepromSize	dw	?	; Size of EEPROM
PollData	db	?	; Polling data value.
FuseType	db	0	; 0:N/A, 1:Type1, 2:Type2, 3:Type3
SyncTry		db	0	;
DestFlag	db	OFF	; Read destination for (OFF:program, ON:data)


;--------------------------------------;
; n[hEFA|[g֌W

S_MISO		equ	BIT5	; MSR.DR

B_RESET		equ	BIT0	; MCR.ER
B_SCK		equ	BIT1	; MCR.RS

B_MOSI		equ	BIT6	; LCR.BREAK


C_EN_PRG1	equ	10101100b	; AVRR}h
C_EN_PRG2	equ	01010011b
C_ERASE1	equ	10101100b
C_ERASE2	equ	10000000b
C_WR_PRG	equ	01000000b
C_RD_PRG	equ	00100000b
C_WR_EEP	equ	11000000b
C_RD_EEP	equ	10100000b
C_WR_FB		equ	10101100b
C_RD_FB1	equ	01011000b
C_RD_FB2	equ	01010000b
C_RD_SIG	equ	00110000b
C_RD_CAL	equ	00111000b

		even
PortNum		dw	1	; Port number (1-4)
ComBase		dw	?	; COM port base address


DELAY		macro	tm
		pusha
		mov	ax,tm
		 call	dly_ms
		popa
		endm


;--------------------------------------;
; ̑

CmdChar		db	0	; 
SlowClock	db	OFF	; 
Verify		db	OFF	; 
CmdVal		dw	?	; 
Argc		db	?
Argv		dw	?,?,?,?,?

Hand		dw	?	; file r/w handle
ReadPtr		dw	?	; buffer ptr


ReadBuff	db	256 dup(?)	; t@Cǂݍ݃obt@
CompBuff	db	10 dup(?)	; ubN\robt@
BlockBuff	db	600 dup(?)	; HEXubNobt@

CodeBuff	db	8192 dup(?)	; vOR[hobt@
DataBuff	db	512 dup(?)	; EEPROMf[^obt@

SignBuff	db	3 dup(?)	; VOl`obt@
FuseByte	db	?		; q[Y
CalByte		db	?		; tiny12 calibration byte



;-----------------------------------------------------------------------------;
; vOR[h

.186
.code

		DEF_PSP
start:
		FPRIN  MessStart	; Startup Message
		FIL_STR <ofs CodeBuff>,<size CodeBuff>,-1
		FIL_STR <ofs DataBuff>,<size DataBuff>,-1

		GET_CMD_PAR Argc,Argv	; Check command line
		mov	bp,ofs Argv
	_while ne, Argc,0
		mov	bx,[bp]
		mov	ax,[bx]
	 _if e, al,'/'
		incw	bx
		CAPS	ah
	  _case e, ah,'P'
		 call	GET_VALH
		mov	PortNum,ax
	  _case e, ah,'S'
		set	SlowClock
	  _case e, ah,'V'
		set	Verify
	  _case e, ah,'F'
		mov	CmdChar,ah
		 call	GET_VALH
		mov	CmdVal,ax
	  _case e, ah,'R'
		mov	CmdChar,ah
		 call	GET_VALH
	   _if e, al,0
		mov	ax,32
	   _endif
		mov	CmdVal,ax
	  _default
		mov	CmdChar,ah
	  _endc
	 _else
		mov	dx,bx
		 call	LOAD_HEX
		jc	dos_err
	 _endif
		incw	bp
		dec	Argc
	_rept

		cje	CmdChar, 'F', do_fuse	; ߕʕ
		cje	CmdChar, 'L', do_lock	;
		cje	CmdChar, 'R', do_read	;
		cje	CmdChar, 'E', do_erase	;
		cjne	CodeSize, 0, do_write	;
		cjne	DataSize, 0, do_write	;

		PRINT  MessUsage
		PRINT  DevList
		$DOS  4ch,RC_SYNTAX


dos_err:	ERR_OUT
		$DOS  4ch,RC_FILE

		PRINTF_F		; Formed print routine
		GET_VALH_F		; Get hexdecimal value routine



;------------------------------------------------;
; S

do_erase:
		 call	get_port	; Get port address
		 call	power_on	; Power ON
		 call	check_device
		PRINT	MessErase
		 call	device_erase	; Chip erase
		 call	rel_port	; Release port
		PRINT	MessPass
		$DOS  4ch,RC_PASS



;------------------------------------------------;
; bNrbg

do_lock:
		 call	get_port	; Get port address
		 call	power_on
		 call	check_device
		PRINT	MessLock
		 call	write_lock
		 call	rel_port	; Release port
		PRINT	MessPass
		$DOS  4ch,RC_PASS



;------------------------------------------------;
; q[Yrbg

do_fuse:
		 call	get_port	; Get port address
		 call	power_on	; Power ON
		 call	check_device	; Check device type
	_if e, FuseType, 0
		 call	rel_port	; Release port
		PRINT	MessNoFuse
		$DOS  4ch,RC_DEV
	_endif
		PRINT	MessFuse
		mov	ax,CmdVal
		 call	write_fuse	; Write fuse bits
		 call	rel_port	; Release port
		PRINT	MessPass
		$DOS  4ch,RC_PASS



;------------------------------------------------;
; vO^f[^ݓ

do_write:
		 call	get_port	; Get port address
		 call	power_on	; Power ON
		 call	check_device	; Check device type

	_if ne, CodeSize, 0		; Write program code
	 _skip nz,<tst Verify>
		PRINT	MessErase
		 call	device_erase	; Chip erase
		 call	power_on	; Reset Device
		PRINT	MessPass
		PRINT	MessCodeP
		clr	bx
	  _repeat CodeSize
		 call	chk_cancel
	   _break ae, bx,FlashSize
		mov	ah,CodeBuff[bx]
		 call	write_flash
		inc	bx
	  _loop
	 _endif
		PRINT	MessVerify
		clr	bx
	 _repeat CodeSize
		 call	chk_cancel
	  _break ae, bx,FlashSize
		 call	read_flash
		mov	al,CodeBuff[bx]
		cjne	al,ah, dp_err
		inc	bx
	 _loop
		PRINT	MessPass
	_endif

	_if ne, DataSize, 0		; Write EEPROM data
	 _skip nz,<tst Verify>
		PRINT	MessDataP
		clr	bx
	  _repeat DataSize
		 call	chk_cancel
	   _break ae, bx,EepromSize
		mov	ah,DataBuff[bx]
		 call	write_eep
		inc	bx
	  _loop
	 _endif
		PRINT	MessVerify
		clr	bx
	 _repeat DataSize
		 call	chk_cancel
	  _break ae, bx,EepromSize
		 call	read_eep
		mov	al,DataBuff[bx]
		cjne	al,ah, dp_err
		inc	bx
	 _loop
		PRINT	MessPass
	_endif

		 call	rel_port	; Release port
		$DOS  4ch,RC_PASS

chk_cancel:	; L[̓`FbN
		movseg	es,SEG_BIOS
		mov	ax,es:BiosKbHead
		cmp	ax,es:BiosKbTail
		movseg	es,cs
		ret e
		$KEY 0
		 call	rel_port	; Release port
		FPRIN  MessCan2
		$DOS  4ch,RC_FAIL

dp_err:		; xt@CG[
		mov	cl,al
		shr	ax,8
		FPRIN  MessErrAdr, bx, cx, ax
		 call	rel_port	; Release port
		$DOS  4ch,RC_FAIL



;------------------------------------------------;
; ǂݍ݁^\

do_read:
		 call	get_port	; Get port address
		 call	power_on	; Power ON
		 call	check_device	; Check device type

		FPRIN  MessRead

		clr	bx		; Read Program memory
	_repeat FlashSize
		 call	read_flash
		mov	CodeBuff[bx],ah
		inc	bx
	_loop

		clr	bx		; Read EEPROM
	_repeat EepromSize
		 call	read_eep
		mov	DataBuff[bx],ah
		inc	bx
	_loop

		 call	read_fuse	; Read fuse
		mov	FuseByte,ah

	_if e, FuseType, 3
		 call	read_cal	; Read Calibration Byte
		mov	CalByte,ah
	_endif

		 call	rel_port	; Release port
		FPRIN  MessPass2

		 call	DISP_HEX	; HEX Output

		$DOS  4ch,RC_PASS



;------------------------------------------------;
; HEXt@Co

DISP_HEX	proc
		PRINT	HeadCode	; Program blocks
		mov	si,ofs CodeBuff
		mov	cx,FlashSize
		 call	DP_BLOCKS

		PRINT	HeadData	; Data blocks
		mov	si,ofs DataBuff
		mov	cx,EepromSize
		 call	DP_BLOCKS

	_if ne, FuseType,0
		PRINT	HeadFuse
	 _repeat 8
		rol	FuseByte,1
		mov	dl,'0'
		adc	dl,0
		$DOS  2
	 _loop
		PRINT	CrLf
	_endif

	_if e, FuseType,3
		PRINT	HeadCal
		mov	al,CalByte
		 call	DP_HEX
		PRINT	CrLf
	_endif
		ret
DISP_HEX	endp


DP_BLOCKS	proc		; Write hex blocks
		clr	bx
	 _while
		push	cx,si,bx
		mov	cx,CmdVal
		 call	DP_BLK
		pop	bx,si,cx
		add	si,CmdVal
		add	bx,CmdVal
		sub	cx,CmdVal
	 _rept nbe
		ret
DP_BLOCKS	endp


DP_BLK		proc		; Write a hex block
		push	cx,si
		mov	al,-1
	_repeat
		and	al,[si]
		inc	si
	_loop
		pop	si,cx
		ret e, al,-1
		mov	dl,':'
		$DOS  2
		clr	dl
		mov	al,cl	; Block Len.
		 call	DP_HEX
		mov	al,bh	; Addr.H
		 call	DP_HEX
		mov	al,bl	; Addr.L
		 call	DP_HEX
		mov	al,0	; Block Type
		 call	DP_HEX
	_repeat			; Data
		lodsb
		 call	DP_HEX
		inc	bx
	_loop
		mov	al,dl	; Sum
		neg	al
		 call	DP_HEX
		mov	dl,CR	; CR
		$DOS  2
		mov	dl,LF	; LF
		$DOS  2
		ret
DP_BLK		endp


DP_HEX		proc			; PUio	AL
		add	dl,al
		 call	dph
	dph:	rol	al,4
		push	ax,dx
		and	al,0fh
		cmp	al,10
	@if ae,<add	al,7>
		add	al,'0'
		mov	dl,al
		$DOS  2
		pop	dx,ax
		ret
DP_HEX		endp



;------------------------------------------------;
; HEXt@Cǂݍ


LOAD_HEX	proc			; HEXt@Cǂݍ
		OPEN_FILE  0		; open HEX file
		ret c
		mov	Hand,ax
		mov	ReadPtr,0
		res	DestFlag

		mov	si,dx
	_while 
	 _if e, bptr[si],'.'
		mov	bx,si
		mov	di,ofs ExtEep
	  _repeat <size ExtEep>
		mov	al,[bx]
		CAPS	al
		inc	di
		inc	bx
		cmp	al,[di][-1]
	  _loop e
	  @if e, <set	DestFlag>
	 _endif
		inc	si
	_rept ne, bptr[si],0

lh_code:	; vOR[hǂݍ
	_while
		 call	READ_BLOCK	; PubNǂݍ
	 _break c
		mov	si,ofs BlockBuff
	 _if e, bptr[si][3],0	; data block ?
		clr	cx
		mov	cl,[si][0]
	  _skip cxz
		mov	bh,[si][1]
		mov	bl,[si][2]
		add	si,4
	   _repeat
		lodsb
	    _if e, DestFlag, OFF
	     _skip ae, bx, <size CodeBuff>
		mov	CodeBuff[bx],al
		inc	bx
	      _if a, bx, CodeSize
		mov	CodeSize,bx
	     __endif
	    _else
	     _skip ae, bx, <size DataBuff>
		mov	DataBuff[bx],al
		inc	bx
	      _if a, bx, DataSize
		mov	DataSize,bx
	     __endif
	    _endif
	   _loop
	 __endif
	_rept
		CLOSE_FILE  Hand
		clc
		ret
LOAD_HEX	endp


READ_BLOCK	proc			; BlockBuffւPubNǂݍ
	_while
		 call	READ_CHR
	 _if e, al,EOF
		stc
		ret
	 _endif
		 call	CHECK_SIGN
	_rept ne, al,':'
		mov	di,ofs BlockBuff
		 call	READ_BYTE
		stosb
		mov	dl,al
		mov	cl,al
		clr	ch
		add	cx,4
	_repeat
		 call	READ_BYTE
		stosb
		add	dl,al
	_loop
		cmp	dl,0
		jne	lh_err
		ret
READ_BLOCK	endp


CHECK_SIGN	proc			; 
		CAPS	al
		mov	si,ofs CompBuff[size CompBuff-2]
		mov	di,ofs CompBuff[size CompBuff-1]
		mov	cx,size CompBuff-1
		std
		rep movsb
		cld
		mov	si,ofs CompBuff[0]
		mov	[si],al
		mov	di,ofs CodeMatch
		mov	cx,size CodeMatch
		repe cmpsb
	@if e, <res	DestFlag>
		mov	si,ofs CompBuff[0]
		mov	di,ofs DataMatch
		mov	cx,size DataMatch
		repe cmpsb
	@if e, <set	DestFlag>
		ret
CHECK_SIGN	endp


READ_BYTE	proc			; HEXPoCgǂݍ
		 call	rb_n
		shl	al,4
		mov	bl,al
		 call	rb_n
		or	al,bl
		ret
rb_n:
		 call	READ_CHR
		CAPS	al
		sub	al,'0'
	_if ae, al,10
		sub	al,7
		cmp	al,16
		jae	lh_err
		cmp	al,10
		jnae	lh_err
	_endif
		ret
READ_BYTE	endp


READ_CHR	proc			; t@CPǂݍ
		push	bx,cx,dx
	_if e, ReadPtr,0
		READ_FILE Hand,<ofs ReadBuff>,<size ReadBuff>
		jc	dos_err
	 _if ne, ax,cx
		mov	bx,ax
		mov	ReadBuff[bx],EOF
	__endif
		mov	bx,ReadPtr
		mov	al,ReadBuff[bx]
		inc	bx
		cmp	bx,size ReadBuff
	@if ae,<clr	bx>
		mov	ReadPtr,bx
		pop	dx,cx,bx
		ret
READ_CHR	endp

lh_err:		PRINT  MessErHex
		$DOS  4ch,RC_FILE



;------------------------------------------------;
; AVR ɃANZX


check_device:	; VOl`ǂݍ݂ƃp[^

		clr	bx
	_repeat 3			; Read signature bytes
		 call	read_sign
		mov	SignBuff[bx],ah
		inc	bx
	_loop
		mov	ax,wptr SignBuff[1]

	_case e, ax, SIGN_2313
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	PollData,7fh
		mov	ax,ofs S2313

	_case e, ax, SIGN_1200
		mov	FlashSize,1024
		mov	EepromSize,64
		mov	PollData,0ffh
		mov	ax,ofs S1200

	_case e, ax, SIGN_4414
		mov	FlashSize,4096
		mov	EepromSize,256
		mov	PollData,7fh
		mov	ax,ofs S4414

	_case e, ax, SIGN_8515
		mov	FlashSize,8192
		mov	EepromSize,512
		mov	PollData,7fh
		mov	ax,ofs S8515

	_case e, ax, SIGN_2333
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	PollData,0ffh
		mov	FuseType,2
		mov	ax,ofs S2333

	_case e, ax, SIGN_4433
		mov	FlashSize,4096
		mov	EepromSize,256
		mov	PollData,0ffh
		mov	FuseType,2
		mov	ax,ofs S4433

	_case e, ax, SIGN_4434
		mov	FlashSize,4096
		mov	EepromSize,256
		mov	PollData,0ffh
		mov	FuseType,1
		mov	ax,ofs S4434

	_case e, ax, SIGN_8535
		mov	FlashSize,8192
		mov	EepromSize,512
		mov	PollData,0ffh
		mov	FuseType,1
		mov	ax,ofs S8535

	_case e, ax, SIGN_2323
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	PollData,0ffh
		mov	FuseType,1
		mov	ax,ofs S2323

	_case e, ax, SIGN_2343
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	PollData,0ffh
		mov	FuseType,1
		mov	ax,ofs S2343

	_case e, ax, SIGN_T12
		mov	FlashSize,1024
		mov	EepromSize,64
		mov	PollData,0ffh
		mov	FuseType,3
		mov	ax,ofs T12

	_case e, ax, SIGN_T22
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	PollData,0ffh
		mov	FuseType,1
		mov	ax,ofs T22

	_case e, ax, SIGN_T15
		mov	FlashSize,1024
		mov	EepromSize,64
		mov	PollData,0ffh
		mov	FuseType,3
		mov	ax,ofs T15

	_case e, ax, 0201h
		FPRIN	NameLocked
	 _skip e, CmdChar,'E'
		$DOS  4ch,RC_DEV
	 _endif
		ret

	_default
		inc	SyncTry
	 _if ae, SyncTry, 3
		FPRIN	NameUnknown, <wptr SignBuff[0]>,<wptr SignBuff[1]>,<wptr SignBuff[2]>
		$DOS  4ch,RC_DEV
	 _endif
		 call	power_on
		jmp	check_device

	_endc

		FPRIN	NameDisp, ax
		ret


device_erase:	; Sf[^
		mov	ah,C_ERASE1	; CMD
		 call	send_avr	;
		mov	ah,C_ERASE2	;
		 call	send_avr	;
		mov	ah,0		;
		 call	send_avr	;
		 call	send_avr	;
		DELAY	30		;
		ret


write_flash:	; vOɃf[^ (BX=addr., AH=data)
		ret e, ah, -1		; When FFh, skip.
		push	cx,bx,ax
		mov	ah,C_WR_PRG	; Set command
		shr	bx,1
	@if c, <set	ah,BIT3>
		 call	send_avr
		mov	ah,bh		; Send address high
		 call	send_avr
		mov	ah,bl		; Send address low
		 call	send_avr
		pop	ax
		 call	send_avr	; Send data, Write start
		pop	bx

	_case e, ah, PollData		; Wait for end of programming
		DELAY	12
	_case e, <wptr SignBuff[1]>,SIGN_1200
		DELAY	12
	_default
		mov	ch,ah
		mov	cl,100
	 _while
		 call	read_flash
	  _break e, ah, ch
	 _rept nz,<dec	cl>
	_endc
		pop	cx
		ret


write_eep:	; EEPROMɃf[^ (BX=addr., AH=data)
		push	cx,ax
		mov	ah,C_WR_EEP	; Set command
		 call	send_avr
		mov	ah,bh		; Set address high
		 call	send_avr
		mov	ah,bl		; Set address low
		 call	send_avr
		pop	ax
		 call	send_avr	; Set data

		mov	al,ah
		not	al
	_case e, ah, PollData		; Wait for end of programming
		DELAY	12
	_case e, al, PollData
		DELAY	12
	_case e, <wptr SignBuff[1]>,SIGN_1200
		DELAY	12
	_default
		mov	ch,ah
		mov	cl,100
	 _while
		 call	read_eep
	  _break e, ah, ch
	 _rept nz,<dec	cl>
	_endc
		pop	cx
		ret


read_flash:	; vOf[^ǂݏo (BX=addr., AH=data)
		push	bx
		mov	ah,C_RD_PRG	; Set command
		shr	bx,1
	@if c, <set	ah,BIT3>
		 call	send_avr
		mov	ah,bh		; Set address high
		 call	send_avr
		mov	ah,bl		; Set address low
		 call	send_avr
		 call	read_avr	; Read data
		pop	bx
		ret


read_eep:	; EEPROMf[^ǂݏo (BX=addr., AH=data)
		mov	ah,C_RD_EEP	; Set command
		 call	send_avr
		mov	ah,bh		; Set address high
		 call	send_avr
		mov	ah,bl		; Set address low
		 call	send_avr
		 call	read_avr	; Read data
		ret


read_sign:	; VOl`ǂݏo (BL=addr., AH=data)
		mov	ah,C_RD_SIG	; Set command
		 call	send_avr
		mov	ah,0		; 0
		 call	send_avr
		mov	ah,bl		; Set address low
		 call	send_avr
		 call	read_avr	; Read data
		ret


write_lock:	; bNrbg
		mov	ah,C_WR_FB	; Command
		 call	send_avr
		mov	ah,11111001b	; Program LB2,LB1
		 call	send_avr
		mov	ah,0
		 call	send_avr
		 call	send_avr
		DELAY	15		; Wait for 15ms
		ret


write_fuse:	; t[Y (AL=data)
		push	ax
		mov	ah,C_WR_FB	; Command
		 call	send_avr
	_case be, FuseType, 2
		pop	ax
		mov	ah,al		; Fuse data
		 call	send_avr
		mov	ah,0
		 call	send_avr

	_case e, FuseType, 3
		mov	ah,10111111b
		 call	send_avr
		 call	send_avr
		pop	ax
		mov	ah,al		; Fuse data

	_endc
		 call	send_avr
		DELAY	15		; Wait for 15ms
		ret


read_fuse:	; t[Yǂݏo (AH=data)
	_case e, FuseType, 1
		mov	ah,C_RD_FB1
		 call	send_avr
		mov	ah,0		; 0
		 call	send_avr
		 call	send_avr
		 call	read_avr	; Read data

	_case ae, FuseType, 2
		mov	ah,C_RD_FB2
		 call	send_avr
		mov	ah,0		; 0
		 call	send_avr
		 call	send_avr
		 call	read_avr	; Read data

	_endc
		ret


read_cal:	; tiny12Lu[VoCgǂݏo
 		mov	ah,C_RD_CAL
		 call	send_avr
		mov	ah,0		; 0
		 call	send_avr
		 call	send_avr
		 call	read_avr	; Read data
		ret


;-------------------------------------------------;
; n[hEFA|[gɃANZX


get_port:	; |[gAhX擾
		mov	bx,PortNum
		dec	bx
		and	bx,3
		shl	bx,1
		movseg	es,SEG_BIOS
		mov	ax,es:BiosComLst[bx]
		movseg	es,cs
		cje	ax,0, gl_np
		mov	ComBase,ax
		 call	dly
		addi	dx,ax,4
		mov	al,0		; AVR RESET
		out	dx,al
		ret

gl_np:		FPRIN  MessNoCom, PortNum	; |[g
		$DOS  4ch,RC_ENV


rel_port:	; |[gJ
		addi	dx,ComBase,3	; (dx=LCR)
		mov	al,11b		; Break = off
		out	dx,al		; /
		ret


power_on:	; AVRvO[hֈڍs
		addi	dx,ComBase,4	; dx=MCR
		mov	al,0		; RESET = "L", SCK = "L"
		out	dx,al		;
		DELAY	10		; 10ms
		mov	al,B_RESET	; RESET = "H"
		out	dx,al		;
		 call	dly		;
		 call	dly		;
		mov	al,0		; RESET = "L"
		out	dx,al		;
		DELAY	30		; 30ms

	_repeat 32
		mov	ah,C_EN_PRG1	; Command synchronization
		 call	send_avr	;
		mov	ah,C_EN_PRG2	;
		 call	send_avr	;
		 call	read_avr	;
		mov	bl,ah		;
		 call	send_avr	;
	 _break e, bl, C_EN_PRG2	; Sync ?, yes break
	 _break nae, SyncTry, 2
		addi	dx,ComBase,4	; (dx=MCR)
		mov	al,B_SCK	; SCK="H"
		out	dx,al		; /
		 call	dly		; 
		mov	al,0		; SCK="L"
		out	dx,al		; /
		 call	dly		; 
	_loop
		ret


send_avr:	; AVRփf[^] (AH=send data)
		push	cx
		addi	dx,ComBase,4	; (dx=MCR)
	_repeat 8
		mov	al,0		; SCK="L"
		out	dx,al		; /
		dec	dx		; (dx=LCR)
	 _if c,<rol	ah,1>		; MOSI=bit for send
		mov	al,B_MOSI	; 
	 _endif				; 
		out	dx,al		; /
		 call	dly
		inc	dx		; (dx=MCR)
		mov	al,B_SCK	; SCK="H"
		out	dx,al		; /
		 call	dly
	_loop
		mov	al,0		; SCK="L"
		out	dx,al		; /
		 call	dly
		pop	cx
		ret


read_avr:	; AVRf[^ǂݍ (AH=read data)
		push	cx
		addi	dx,ComBase,4	; (dx=MCR)
		clr	al
	_repeat 8
		shl	ah,1
		add	dx,2		; (dx=MSR)
		in	al,dx		; Read MSR.RI(MISO)
		test	al,S_MISO
	 @ifn z,<set	ah,BIT0>
		sub	dx,2		; (dx=MCR)
		mov	al,B_SCK	; SCK="H"
		out	dx,al		; /
		 call	dly
		mov	al,0		; SCK="L"
		out	dx,al		; /
		 call	dly
	_loop
		pop	cx
		ret


dly:		; S҂ (I/O[hgp)
		push	ax,cx,dx
		mov	dx,ComBase
	_if e, SlowClock,ON
		mov	cx,8
	_else
		mov	cx,1
	_endif
	_repeat
		in	al,dx
		in	al,dx
		in	al,dx
		in	al,dx
	_loop
		pop	dx,cx,ax
		ret


dly_ms:		; ax(ms) ҂(BIOSgp)
		inc	ax
		mov	dx,1000
		mul	dx
		mov	cx,dx
		mov	dx,ax
		$SYSTEM  86h
		ret


		$end	start

