;-----------------------------------------------------------------------------;
; `uqp݃vO (AVRXp)
;
;Date:     2000.08.02
;Revision: 0.10
;Authoer:  ChaN (T.Akamatsu)


include	stddef.inc
include	str.inc
include	file.inc
include	ibmpc.inc

;------------------------------------------------;
; [NGA

.model t
.data

;--------------------------------------;
; e탁bZ[W

MessStart	db	'AVRXP - AVR parallel programming tool for AVRX. R0.10 (C)ChaN,2000.%n'
		db	'        Support: http://elm-chan.org/%n%n',0
MessNoLpt	db	'No LPT%ui port in this system.%n',0
MessNoAda	db	'AVRX adapter is not attached on the LPT%ui.%n',0
MessUsage	db	'Write code and data      : avrxp <hex file> [<hex file>] ...',CR,LF
		db	'Read code, data and fuse : avrxp /r',CR,LF
		db	'Chip erase               : avrxp /e',CR,LF
		db	'Write fuse bits          : avrxp /f<h>',CR,LF
		db	'Lock device              : avrxp /l',CR,LF
		db	'Enforce 8 pin AVR        : avrxp /8 ...',CR,LF
		db	'Specify port number LPTn : avrxp /p<n> ...',CR,LF
		db	CR,LF,'$'
MessReq		db	'Put an AVR on the socket, and then type any key...',0
MessClr		db	'%m                                                  %m',0
MessErHex	db	'Hex file error.',CR,LF,'$'
MessCodeP	db	'Flash: Writing...$'
MessDataP	db	'EEPROM: Writing...$'
MessVerify	db	'Verifying...$'
MessErrAdr	db	'error %h4:%h2-%h2%n',0
MessFuse	db	'Writing Fuse bits...$'
MessLock	db	'Writing Lock bits...$'
MessErase	db	'Chip Erasing...$'
MessPass	db	'OK'
CrLf		db	CR,LF,'$'
MessRead	db	'Reading...',0
MessPass2	db	'OK%n',0
MessCan2	db	'Canceled%n',0

ExtEep		db	'.EEP'
HeadCode	db	'[PROGRAM CODE]',CR,LF,'$'
HeadData	db	'[EEPROM DATA]',CR,LF,'$'
HeadFuse	db	'[FUSE DATA]',CR,LF,'$'
HeadCal		db	'[CAL. BYTE]',CR,LF,'$'

CodeMatch	db	'MARGORP'	; PROGRAM
DataMatch	db	'MORPEE'	; EEPROM

		; Program return codes
RC_PASS		equ	0	; Successful
RC_FAIL		equ	1	; Verify error
RC_FILE		equ	2	; File operation error
RC_DEV		equ	3	; Unknown device type
RC_ENV		equ	4	; Envilonment error
RC_SYNTAX	equ	5	; Command line syntax error


;--------------------------------------;
; foCX֌W

SIGN_2313	equ	0191h
SIGN_1200	equ	0190h
SIGN_2333	equ	0591h
SIGN_4433	equ	0392h
SIGN_4414	equ	0192h
SIGN_8515	equ	0193h
SIGN_4434	equ	0292h
SIGN_8535	equ	0393h
SIGN_2323	equ	0291h
SIGN_2343	equ	0391h
SIGN_T10	equ	0390h
SIGN_T11	equ	0490h
SIGN_T12	equ	0590h
SIGN_T22	equ	0691h
SIGN_T28	equ	0791h


DevList		db	'Supported Devices:',CR,LF
		db	'2313,1200,2333,4433,4414,8515,4434,8535,tiny28',CR,LF
		db	'2323,2343,tiny10,tiny11,tiny12,tiny22',CR,LF
		db	'$'
NameDisp	db	'Detected device is AT%s.%n%n',0
NameUnknown	db	'Device is not working or not supported device (%h2,%h2,%h2).%n',0
MessTry8	db	'Attempting to detect as 8 pin AVR...%n',0

S1200		db	'90S1200',0
S2313		db	'90S2313',0
S2333		db	'90S2333',0
S4414		db	'90S4414',0
S4433		db	'90S4433',0
S4434		db	'90S4434',0
S8515		db	'90S8515',0
S8535		db	'90S8535',0
S2323		db	'90S2323',0
S2343		db	'90S2343',0
T10		db	'tiny10',0
T11		db	'tiny11',0
T12		db	'tiny12',0
T22		db	'tiny22',0
T28		db	'tiny28',0


CodeSize	dw	0	; Loaded program code size
DataSize	dw	0	; Loaded eeprom data size
FlashSize	dw	?	; Size of program rom
EepromSize	dw	?	; Size of EEPROM
FuseType	db	0	; 0:BS=1 for read, 1:BS=0 for read
Calib		db	0	; 1:device has a caribration byte
Pin8		db	OFF	; OFF:20pin, ON:8pin
DestFlag	db	OFF	; Read destination for (OFF:program, ON:data)


;--------------------------------------;
; n[hEFA|[g֌W

				; Xe[^X|[grbg蓖
S_PE		equ	BIT5	; B_CHK
S_ACK		equ	BIT6	; SREG Shift Out
S_BUSY		equ	BIT7	; RDY/BUSY

				; f[^|[grbg蓖
B_XT1		equ	BIT0	; XTAL1
B_CLK		equ	BIT0	; AVR8 Clock
B_OE		equ	BIT1	; OE
B_DAT		equ	BIT1	; AVR8 Data In
B_WR		equ	BIT2	; WR
B_CMD		equ	BIT2	; AVR8 Instr. In
B_BS		equ	BIT3	; BS
B_XA0		equ	BIT4	; XA0
B_SDAT		equ	BIT4	; SREG Shift In
B_XA1		equ	BIT5	; XA1
B_SCLK		equ	BIT6	; SREG Clock
B_CHK		equ	BIT7	; S_PE
B_SCMD		equ	BIT7	; SREG Cmd

C_WR_PRG	equ	00010000b	; AVR pR}h
C_RD_PRG	equ	00000010b
C_WR_EEP	equ	00010001b
C_RD_EEP	equ	00000011b
C_WR_FB		equ	01000000b
C_RD_FB		equ	00000100b
C_WR_LB		equ	00100000b
C_RD_SIG	equ	00001000b
C_ERASE		equ	10000000b

					; AVR VAR}h
C_CE1		equ	1000000001001100b
C_CE2		equ	01100100b
C_CE3		equ	01101100b
C_CE4		equ	01001100b
C_WPA1		equ	0001000001001100b
C_WPA2		equ	00011100b
C_WPA3		equ	00001100b
C_WPDL1		equ	00101100b
C_WPDL2		equ	01100100b
C_WPDL3		equ	01101100b
C_WPDH1		equ	00101100b
C_WPDH2		equ	01110100b
C_WPDH3		equ	01111100b
C_RPA1		equ	0000001001001100b
C_RPA2		equ	00011100b
C_RPA3		equ	00001100b
C_RPDL1		equ	01101000b
C_RPDL2		equ	01101100b
C_RPDH1		equ	01111000b
C_RPDH2		equ	01111100b
C_WEA1		equ	0001000101001100b
C_WEA2		equ	00001100b
C_WED1		equ	00101100b
C_WED2		equ	01100100b
C_WED3		equ	01101100b
C_REA1		equ	0000001101001100b
C_REA2		equ	00001100b
C_RED1		equ	01101000b
C_RED2		equ	01101100b
C_WFD1		equ	0100000001001100b
C_WFD2		equ	00101100b
C_WFD3		equ	01100100b
C_WFD4		equ	01101100b
C_WLD1		equ	0010000001001100b
C_WLD2		equ	00101100b
C_WLD3		equ	01100100b
C_WLD4		equ	01101100b
C_RFD1		equ	0000010001001100b
C_RFD2		equ	01111000b	; Data sheet 
C_RFD3		equ	01101100b
C_RSD1		equ	0000100001001100b
C_RSD2		equ	00001100b
C_RSD3		equ	01101000b
C_RSD4		equ	01101100b
C_RCD1		equ	0000100001001100b
C_RCD2		equ	00001100b
C_RCD3		equ	01111000b
C_RCD4		equ	01101100b


		even
PortNum		dw	1	; Port number
LptBase		dw	?	; LPT data port address
PortReg		db	?,?	; LPT data port


DELAY		macro	tm
		pusha
		mov	ax,tm
		 call	dly_ms
		popa
		endm


;--------------------------------------;
; ̑

CmdChar		db	0	; 
NoWait		db	OFF	; 
CmdVal		dw	?	; 
Argc		db	?
Argv		dw	5 dup(?)

Hand		dw	?	; file r/w handle
ReadPtr		dw	?		; buffer ptr


ReadBuff	db	256 dup(?)	; t@Cǂݍ݃obt@
CompBuff	db	10 dup(?)	; ubN\robt@
BlockBuff	db	600 dup(?)	; HEXubNobt@


CodeBuff	db	8192 dup(?)	; vOR[hobt@
DataBuff	db	512 dup(?)	; EEPROMf[^obt@

SignBuff	db	3 dup(?)	; VOl`obt@
FuseByte	db	?		; t[Y
CalByte		db	?		; tiny12 calibration byte



;-----------------------------------------------------------------------------;
; vOR[h

.186
.code

		DEF_PSP
start:
		FPRIN  MessStart	; Startup Message
		FIL_STR <ofs CodeBuff>,<size CodeBuff>,-1
		FIL_STR <ofs DataBuff>,<size DataBuff>,-1

		GET_CMD_PAR Argc,Argv	; Check command line
		mov	bp,ofs Argv
	_while ne, Argc,0
		mov	bx,[bp]
		mov	ax,[bx]
	 _if e, al,'/'
		incw	bx
		CAPS	ah
	  _case e, ah,'8'
		set	Pin8
	  _case e, ah,'P'
		 call	GET_VALH
		mov	PortNum,ax
	  _case e, ah,'F'
		mov	CmdChar,ah
		 call	GET_VALH
		mov	CmdVal,ax
	  _case e, ah,'R'
		mov	CmdChar,ah
		 call	GET_VALH
	   _if e, al,0
		mov	ax,32
	   _endif
		mov	CmdVal,ax
	  _case e, ah,'N'
		set	NoWait
	  _default
		mov	CmdChar,ah
	  _endc
	 _else
		mov	dx,bx
		 call	LOAD_HEX
		jc	dos_err
	 _endif
		incw	bp
		dec	Argc
	_rept

		cje	CmdChar, 'F', do_fuse	; ߕʕ
		cje	CmdChar, 'L', do_lock	;
		cje	CmdChar, 'R', do_read	;
		cje	CmdChar, 'E', do_erase	;
		cjne	CodeSize, 0, do_write	;

		PRINT  MessUsage
		PRINT  DevList
		$DOS  4ch,RC_SYNTAX


dos_err:	ERR_OUT
		$DOS  4ch,RC_FILE

		PRINTF_F		; Formed print routine
		GET_VALH_F		; Get hexdecimal value routine



;------------------------------------------------;
; S

do_erase:
		 call	get_port	; Get port address
		 call	put_device	; Request to put
		 call	power_on	; Power ON
		 call	check_device	; Check device type
		PRINT	MessErase
		 call	device_erase	; Chip erase
		PRINT	MessPass
		 call	power_off	; Power OFF
		$DOS  4ch,RC_PASS



;------------------------------------------------;
; bNrbgݓ

do_lock:
		 call	get_port	; Get port address
		 call	put_device	; Request to put
		 call	power_on	; Power ON
		 call	check_device	; Check device type
		PRINT	MessLock
		 call	write_lock
		PRINT	MessPass
		 call	power_off	; Power OFF
		$DOS  4ch,RC_PASS



;------------------------------------------------;
; q[Yrbg

do_fuse:
		 call	get_port	; Get port address
		 call	put_device	; Request to put
		 call	power_on	; Power ON
		 call	check_device	; Check device type
		PRINT	MessFuse
		mov	ax,CmdVal
		 call	write_fuse	; Write fuse bits
		PRINT	MessPass
		 call	power_off	; Power OFF
		$DOS  4ch,RC_PASS



;------------------------------------------------;
; vO^f[^ݓ

do_write:
		 call	get_port	; Get port address
		 call	put_device	; Request to put
		 call	power_on	; Power ON
		 call	check_device	; Check device type

		PRINT	MessErase
		 call	device_erase	; Chip erase
		PRINT	MessPass

		PRINT	MessCodeP	; Write & Verify program code
		clr	bx
	_repeat CodeSize
		 call	chk_cancel
	 _break ae, bx,FlashSize
		mov	ah,CodeBuff[bx]
		 call	write_flash
		inc	bx
	_loop
		PRINT	MessVerify
		clr	bx
	_repeat CodeSize
		 call	chk_cancel
	 _break ae, bx,FlashSize
		 call	read_flash
		mov	al,CodeBuff[bx]
		cjne	al,ah, dp_err
		inc	bx
	_loop
		PRINT	MessPass

	_skip e, DataSize, 0		; Write EEPROM data
	 _skip e, EepromSize, 0
		PRINT	MessDataP
		clr	bx
	  _repeat DataSize
		 call	chk_cancel
	   _break ae, bx,EepromSize
		mov	ah,DataBuff[bx]
		 call	write_eep
		inc	bx
	  _loop
		PRINT	MessVerify
		clr	bx
	  _repeat DataSize
		 call	chk_cancel
	   _break ae, bx,EepromSize
		 call	read_eep
		mov	al,DataBuff[bx]
		cjne	al,ah, dp_err
		inc	bx
	  _loop
		PRINT	MessPass
	__endif

		 call	power_off	; Power OFF
		$DOS  4ch,RC_PASS


chk_cancel:	; L[̓`FbN
		movseg	es,SEG_BIOS
		mov	ax,es:BiosKbHead
		cmp	ax,es:BiosKbTail
		movseg	es,cs
		ret e
		$KEY 0
		FPRIN  MessCan2
		 call	power_off
		$DOS  4ch,RC_FAIL

dp_err:		; xt@CG[
		mov	cl,al
		shr	ax,8
		FPRIN  MessErrAdr, bx, cx, ax
		 call	power_off	; Power OFF
		$DOS  4ch,RC_FAIL



;------------------------------------------------;
; ǂݍ݁^\

do_read:
		 call	get_port	; Get port address
		 call	put_device	; Request to put
		 call	power_on	; Power ON
		 call	check_device	; Check device type

		FPRIN  MessRead

		clr	bx		; Read Program memory
	_repeat FlashSize
		 call	read_flash
		mov	CodeBuff[bx],ah
		inc	bx
	_loop

		clr	bx		; Read EEPROM
	_repeat EepromSize
	 _break cxz
		 call	read_eep
		mov	DataBuff[bx],ah
		inc	bx
	_loop

		 call	read_fuse	; Read Fuse bits
		mov	FuseByte,ah

	_if e,  Calib, 1
		 call	read_cal	; Read Calibration Byte
		mov	CalByte,al
	_endif

		 call	power_off	; Power OFF

		FPRIN  MessPass2

		 call	DISP_HEX	; HEX Output

		$DOS  4ch,RC_PASS



;------------------------------------------------;
; foCX}Egv

put_device:
	_if e, NoWait, OFF
		FPRIN	MessReq
		$DOS  8
		FPRIN	MessClr
	_endif
		ret


;------------------------------------------------;
; HEXt@Co

BLK_SIZE	equ	32	; HEX block size

DISP_HEX	proc
		PRINT	HeadCode	; Program blocks
		mov	si,ofs CodeBuff
		mov	cx,FlashSize
		 call	DP_BLOCKS

	_skip e, EepromSize, 0
		PRINT	HeadData	; Data blocks
		mov	si,ofs DataBuff
		mov	cx,EepromSize
		 call	DP_BLOCKS
	_endif

		PRINT	HeadFuse	; Fuse bits
	_repeat 8
		rol	FuseByte,1
		mov	dl,'0'
		adc	dl,0
		$DOS  2
	_loop
		PRINT	CrLf

	_if e,  Calib, 1
		PRINT	HeadCal
		mov	al,CalByte
		 call	DP_HEX
		PRINT	CrLf
	_endif

		ret
DISP_HEX	endp


DP_BLOCKS	proc		; Write hex blocks
		clr	bx
	 _while
		push	cx,si,bx
		mov	cx,CmdVal
		 call	DP_BLK
		pop	bx,si,cx
		add	si,CmdVal
		add	bx,CmdVal
		sub	cx,CmdVal
	 _rept nbe
		ret
DP_BLOCKS	endp


DP_BLK		proc		; Write a hex block
		push	cx,si
		mov	al,-1
	_repeat
		and	al,[si]
		inc	si
	_loop
		pop	si,cx
		ret e, al,-1
		mov	dl,':'
		$DOS  2
		clr	dl
		mov	al,cl	; Block Len.
		 call	DP_HEX
		mov	al,bh	; Addr.H
		 call	DP_HEX
		mov	al,bl	; Addr.L
		 call	DP_HEX
		mov	al,0	; Block Type
		 call	DP_HEX
	_repeat			; Data
		lodsb
		 call	DP_HEX
		inc	bx
	_loop
		mov	al,dl	; Sum
		neg	al
		 call	DP_HEX
		mov	dl,CR	; CR
		$DOS  2
		mov	dl,LF	; LF
		$DOS  2
		ret
DP_BLK		endp


DP_HEX		proc			; PUio	AL
		add	dl,al
		 call	dph
	dph:	rol	al,4
		push	ax,dx
		and	al,0fh
		cmp	al,10
	@if ae,<add	al,7>
		add	al,'0'
		mov	dl,al
		$DOS  2
		pop	dx,ax
		ret
DP_HEX		endp



;------------------------------------------------;
; HEXt@Cǂݍ


LOAD_HEX	proc			; HEXt@Cǂݍ
		OPEN_FILE  0		; open HEX file
		ret c
		mov	Hand,ax
		mov	ReadPtr,0
		res	DestFlag

		mov	si,dx
	_while 
	 _if e, bptr[si],'.'
		mov	bx,si
		mov	di,ofs ExtEep
	  _repeat <size ExtEep>
		mov	al,[bx]
		CAPS	al
		inc	di
		inc	bx
		cmp	al,[di][-1]
	  _loop e
	  @if e, <set	DestFlag>
	 _endif
		inc	si
	_rept ne, bptr[si],0

lh_code:	; vOR[hǂݍ
	_while
		 call	READ_BLOCK	; PubNǂݍ
	 _break c
		mov	si,ofs BlockBuff
	 _if e, bptr[si][3],0	; data block ?
		clr	cx
		mov	cl,[si][0]
	  _skip cxz
		mov	bh,[si][1]
		mov	bl,[si][2]
		add	si,4
	   _repeat
		lodsb
	    _if e, DestFlag, OFF
	     _skip ae, bx, <size CodeBuff>
		mov	CodeBuff[bx],al
		inc	bx
	      _if a, bx, CodeSize
		mov	CodeSize,bx
	     __endif
	    _else
	     _skip ae, bx, <size DataBuff>
		mov	DataBuff[bx],al
		inc	bx
	      _if a, bx, DataSize
		mov	DataSize,bx
	     __endif
	    _endif
	   _loop
	 __endif
	_rept
		CLOSE_FILE  Hand
		clc
		ret
LOAD_HEX	endp


READ_BLOCK	proc			; BlockBuffւPubNǂݍ
	_while
		 call	READ_CHR
	 _if e, al,EOF
		stc
		ret
	 _endif
		 call	CHECK_SIGN
	_rept ne, al,':'
		mov	di,ofs BlockBuff
		 call	READ_BYTE
		stosb
		mov	dl,al
		mov	cl,al
		clr	ch
		add	cx,4
	_repeat
		 call	READ_BYTE
		stosb
		add	dl,al
	_loop
		cmp	dl,0
		jne	lh_err
		ret
READ_BLOCK	endp


CHECK_SIGN	proc			; 
		CAPS	al
		mov	si,ofs CompBuff[size CompBuff-2]
		mov	di,ofs CompBuff[size CompBuff-1]
		mov	cx,size CompBuff-1
		std
		rep movsb
		cld
		mov	si,ofs CompBuff[0]
		mov	[si],al
		mov	di,ofs CodeMatch
		mov	cx,size CodeMatch
		repe cmpsb
	@if e, <res	DestFlag>
		mov	si,ofs CompBuff[0]
		mov	di,ofs DataMatch
		mov	cx,size DataMatch
		repe cmpsb
	@if e, <set	DestFlag>
		ret
CHECK_SIGN	endp


READ_BYTE	proc			; HEXPoCgǂݍ
		 call	rb_n
		shl	al,4
		mov	bl,al
		 call	rb_n
		or	al,bl
		ret
rb_n:
		 call	READ_CHR
		CAPS	al
		sub	al,'0'
	_if ae, al,10
		sub	al,7
		cmp	al,16
		jae	lh_err
		cmp	al,10
		jnae	lh_err
	_endif
		ret
READ_BYTE	endp


READ_CHR	proc			; Pǂݍ
		push	bx,cx,dx
	_if e, ReadPtr,0
		READ_FILE Hand,<ofs ReadBuff>,<size ReadBuff>
		jc	dos_err
	 _if ne, ax,cx
		mov	bx,ax
		mov	ReadBuff[bx],EOF
	__endif
		mov	bx,ReadPtr
		mov	al,ReadBuff[bx]
		inc	bx
		cmp	bx,size ReadBuff
	@if ae,<clr	bx>
		mov	ReadPtr,bx
		pop	dx,cx,bx
		ret
READ_CHR	endp

lh_err:		PRINT  MessErHex
		$DOS  4ch,RC_FILE



;------------------------------------------------;
; AVRANZX


check_device:	; VOl`ǂݍ݂ƃp[^
		 call	read_signs
		mov	ax,wptr SignBuff[1]

	_case e, ax, SIGN_2313
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	ax,ofs S2313

	_case e, ax, SIGN_1200
		mov	FlashSize,1024
		mov	EepromSize,64
		mov	ax,ofs S1200

	_case e, ax, SIGN_2333
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	FuseType,1
		mov	ax,ofs S2333

	_case e, ax, SIGN_4433
		mov	FlashSize,4096
		mov	EepromSize,256
		mov	FuseType,1
		mov	ax,ofs S4433

	_case e, ax, SIGN_4414
		mov	FlashSize,4096
		mov	EepromSize,256
		mov	ax,ofs S4414

	_case e, ax, SIGN_8515
		mov	FlashSize,8192
		mov	EepromSize,512
		mov	ax,ofs S8515

	_case e, ax, SIGN_4434
		mov	FlashSize,4096
		mov	EepromSize,256
		mov	ax,ofs S4434

	_case e, ax, SIGN_8535
		mov	FlashSize,8192
		mov	EepromSize,512
		mov	ax,ofs S8535

	_case e, ax, SIGN_2323
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	ax,ofs S2323

	_case e, ax, SIGN_2343
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	ax,ofs S2343

	_case e, ax, SIGN_T10
		mov	FlashSize,1024
		mov	EepromSize,0
		mov	ax,ofs T10

	_case e, ax, SIGN_T11
		mov	FlashSize,1024
		mov	EepromSize,0
		mov	ax,ofs T11

	_case e, ax, SIGN_T12
		mov	FlashSize,1024
		mov	EepromSize,64
		mov	ax,ofs T12

	_case e, ax, SIGN_T22
		mov	FlashSize,2048
		mov	EepromSize,128
		mov	Calib,1
		mov	ax,ofs T22

	_case e, ax, SIGN_T28
		mov	FlashSize,2048
		mov	EepromSize,0
		mov	Calib,1
		mov	ax,ofs T28

	_default
		 call	power_off
		FPRIN	NameUnknown, <wptr SignBuff[0]>,<wptr SignBuff[1]>,<wptr SignBuff[2]>
	 _if e, Pin8, ON
		$DOS  4ch,RC_DEV
	 _endif
		set	Pin8
		FPRIN	MessTry8
		DELAY	50
		 call	power_on
		jmp	check_device

	_endc

		FPRIN	NameDisp, ax
		ret



device_erase:	; Sf[^
		cje	Pin8, ON, device_erase8
		mov	ah,C_ERASE	; CMD
		 call	send_cmd	;
		 call	wr_pulse	; WR pulse
		DELAY	20		; 20ms ҂
		ret
device_erase8:
		mov	dx,C_CE1
		 call	xfer
		mov	dx,C_CE2
		 call	xfer
		mov	dx,C_CE3
		 call	xfer
		DELAY	20
		mov	dx,C_CE4
		 call	xfer
		DELAY	20
		ret



write_fuse:	; q[Yrbg
		cje	Pin8, ON, write_fuse8
		push	ax
		mov	ah,C_WR_FB	; Command
		 call	send_cmd
		pop	ax
		mov	ah,al		; Fuse data
		 call	send_data
		 call	wr_pulse2	; WR pulse for 1ms
		 call	wait_ready	; Wait for RDY = H
		ret
write_fuse8:
		mov	dx,C_WFD1
		 call	xfer
		mov	dx,C_WFD2
		mov	dh,al
		 call	xfer
		mov	dx,C_WFD3
		 call	xfer
		DELAY	10
		mov	dx,C_WFD4
		 call	xfer
		DELAY	10
		ret



read_fuse:	; q[Yrbgǂݏo
		cje	Pin8, ON, read_fuse8
		mov	ah,C_RD_FB	; Read Fuse
		 call	send_cmd
	_skip e, FuseType, 1
		set	PortReg,B_BS
	_endif
		 call	read_data
		ret
read_fuse8:
		mov	dx,C_RFD1
		 call	xfer
		mov	dx,C_RFD2
		 call	xfer
		mov	dx,C_RFD3
		 call	xfer
		mov	ah,dh
		ret



write_lock:	; bNrbg
		cje	Pin8, ON, write_lock8
		mov	ah,C_WR_LB	; Command
		 call	send_cmd
		mov	ah,11111001b	; Lock data (both LB1,LB2)
		 call	send_data
		 call	wr_pulse2	; WR pulse for 1ms
		 call	wait_ready	; Wait for RDY = H
		ret
write_lock8:
		mov	dx,C_WLD1
		 call	xfer
		mov	dx,C_WLD2
		mov	dh,11111001b	; LB1,2
		 call	xfer
		mov	dx,C_WLD3
		 call	xfer
		mov	dx,C_WLD4
		 call	xfer
		DELAY	10
		ret



write_flash:	; vOɃf[^ (BX=addr., AH=data)
		cje	Pin8, ON, write_flash8
	_if e, bx,0
		push	ax
		mov	ah,C_WR_PRG
		 call	send_cmd
		pop	ax
	_endif
		push	bx
		shr	bx,1
	_if nc				; LOWȂ ADDR,DATA
		push	ax
		mov	ah,bl		; Set address low
		res	PortReg,B_BS
		 call	send_addr
	 _if e, bl,0
		mov	ah,bh		; Set address high
		set	PortReg,B_BS
		 call	send_addr
	 _endif
		pop	ax
		 call	send_data	; Set data

	_else				; HIGHȂ ADDRȗ
		 call	send_data	; Set data
		set	PortReg,B_BS	; BS =  H
	_endif
		 call	wr_pulse	; WR pulse
		 call	wait_ready	; Wait for RDY = H
		pop	bx
		ret
write_flash8:
		push	bx
		shr	bx,1
	_if nc				; LOWȂ ADDR,DATA
		mov	dx,C_WPA1	; AhX
		 call	xfer		; 
		mov	dx,C_WPA2	; 
		mov	dh,bh		; 
		 call	xfer		; 
		mov	dx,C_WPA3	; 
		mov	dh,bl		; 
		 call	xfer		; /
		mov	dx,C_WPDL1	; f[^(low)
		mov	dh,ah		; 
		 call	xfer		; 
		mov	dx,C_WPDL2	; 
		 call	xfer		; 
		mov	dx,C_WPDL3	; 
		 call	xfer		; /
	_else				; HIGHȂ ADDRȗ
		mov	dx,C_WPDH1	; f[^(low)
		mov	dh,ah		; 
		 call	xfer		; 
		mov	dx,C_WPDH2	; 
		 call	xfer		; 
		mov	dx,C_WPDH3	; 
		 call	xfer		; /
	_endif
		 call	wait_ready
		pop	bx
		ret



write_eep:	; EEPROMɃf[^ (BX=addr., AH=data)
		cje	Pin8, ON, write_eep8
	_if e, bx, 0
		push	ax
		mov	ah,C_WR_EEP
		 call	send_cmd
		pop	ax
	_endif
		push	ax
		mov	ah,bl		; Set address low
		res	PortReg,B_BS
		 call	send_addr
	_if e, bl,0
		mov	ah,bh		; Set address high
		set	PortReg,B_BS
		 call	send_addr
	_endif
		pop	ax
		 call	send_data	; Set data
		 call	wr_pulse	; WR pulse
		 call	wait_ready	; Wait for RDY = H
		ret
write_eep8:
		mov	dx,C_WEA1	; AhX
		 call	xfer		; 
		mov	dx,C_WEA2	; 
		mov	dh,bl		; 
		 call	xfer		; 
		mov	dx,C_WED1	; f[^(low)
		mov	dh,ah		; 
		 call	xfer		; 
		mov	dx,C_WED2	; 
		 call	xfer		; 
		mov	dx,C_WED3	; 
		 call	xfer		; /
		 call	wait_ready
		ret



read_flash:	; vOf[^ǂݏo (BX=addr., AH=data)
		cje	Pin8, ON, read_flash8
	_if e, bx, 0
		mov	ah,C_RD_PRG
		 call	send_cmd
	_endif
		push	bx
		shr	bx,1
	_if nc				; LOWȂ ADDR,DATA
		mov	ah,bl		; Set Addr.Low
		res	PortReg,B_BS
		 call	send_addr
	 _if e, bl,0
		mov	ah,bh		; Set Addr.High
		set	PortReg,B_BS
		 call	send_addr
		res	PortReg,B_BS
	 _endif
	_else				; HIGHȂ ADDRȗ
		set	PortReg,B_BS	; BS = H
	_endif
		 call	read_data	; Read data
		pop	bx
		ret
read_flash8:
		push	bx
		shr	bx,1
	_if nc				; LOWȂ ADDR,DATA
		mov	dx,C_RPA1	; AhX
		 call	xfer		; 
		mov	dx,C_RPA2	; 
		mov	dh,bh		; 
		 call	xfer		; 
		mov	dx,C_RPA3	; 
		mov	dh,bl		; 
		 call	xfer		; /
		mov	dx,C_RPDL1	; f[^(low)
		 call	xfer		; 
		mov	dx,C_RPDL2	; 
		 call	xfer		; /
	_else				; HIGHȂ ADDRȗ
		mov	dx,C_RPDH1	; f[^(high)
		 call	xfer		; 
		mov	dx,C_RPDH2	; 
		 call	xfer		; /
	_endif
		mov	ah,dh
		pop	bx
		ret



read_eep:	; EEPROMf[^ǂݏo (BX=addr., AH=data)
		cje	Pin8, ON, read_eep8
	_if e, bx, 0
		mov	ah,C_RD_EEP
		 call	send_cmd
	_endif
		mov	ah,bl		; Set Addr.Low
		res	PortReg,B_BS
		 call	send_addr
	_if e, bl,0
		mov	ah,bh		; Set Addr.High
		set	PortReg,B_BS
		 call	send_addr
		res	PortReg,B_BS
	_endif
		 call	read_data	; Read data
		ret
read_eep8:
		mov	dx,C_REA1	; AhX
		 call	xfer		; 
		mov	dx,C_REA2	; 
		mov	dh,bl		; 
		 call	xfer		; /
		mov	dx,C_RED1	; f[^(low)
		 call	xfer		; 
		mov	dx,C_RED2	; 
		 call	xfer		; 
		mov	ah,dh		; /
		ret



read_signs:	; VOl`ǂݏo SignBuff
		cje	Pin8, ON, read_signs8
		mov	ah,C_RD_SIG
		 call	send_cmd
		clr	bx
	_repeat 3
		mov	ah,bl		; Set address
		 call	send_addr
		 call	read_data	; Read data
		mov	SignBuff[bx],ah
		inc	bx
	_loop
		ret
read_signs8:
		clr	bx
	_repeat 3
		mov	dx,C_RSD1
		 call	xfer
		mov	dx,C_RSD2
		mov	dh,bl
		 call	xfer
		mov	dx,C_RSD3
		 call	xfer
		mov	dx,C_RSD4
		 call	xfer
		mov	SignBuff[bx],dh
		inc	bx
	_loop
		ret



read_cal:	; Calibration Byte ǂݏo
		mov	dx,C_RCD1
		 call	xfer
		mov	dx,C_RCD2
		 call	xfer
		mov	dx,C_RCD3
		 call	xfer
		mov	dx,C_RCD4
		 call	xfer
		mov	al,dh
		ret



send_cmd:	; AVRփpR}hM (AH=command)
		 call	send_reg	; Set data to DATAn
		mov	dx,LptBase
		mov	al,PortReg
		set	al,B_XA1	; XAn = <Command>
		res	al,B_XA0+B_BS	; BS = L
		out	dx,al		; /
		set	al,B_XT1	; XTAL1 = H
		out	dx,al		; /
		res	al,B_XT1	; XTAL1 = L
		out	dx,al		; /
		mov	PortReg,al
		ret



send_addr:	; AVRփpAhXM (AH=address, PortReg.B_BS=H/L)
		 call	send_reg	; Set address high
		mov	dx,LptBase
		mov	al,PortReg
		res	al,B_XA0+B_XA1	; XAn = <Address>
		out	dx,al		; /
		set	al,B_XT1	; XTAL1 = H
		out	dx,al		; /
		res	al,B_XT1	; XTAL1 = L
		out	dx,al		; /
		mov	PortReg,al
		ret



send_data:	; AVRփpf[^LM (ah=data)
		 call	send_reg	; Set data
		mov	dx,LptBase
		mov	al,PortReg
		set	al,B_XA0	; XAn = <Data>
		res	al,B_XA1+B_BS	; BS = L
		out	dx,al		; /
		set	al,B_XT1	; XTAL1 = H
		out	dx,al		; /
		res	al,B_XT1	; XTAL1 = L
		out	dx,al		; /
		mov	PortReg,al
		ret



get_port:	; LPT|[g擾ƃA_v^ڑ`FbN
		mov	bx,PortNum
		dec	bx
		and	bx,3
		shl	bx,1
		movseg	es,SEG_BIOS
		mov	ax,es:BiosLptLst[bx]
		movseg	es,cs
		cje	ax,0, gl_np
		mov	LptBase,ax
		outb	LptBase,B_CHK
		inc	dx
		in	al,dx
		test	al,S_PE
		jz	gl_na
		outb	LptBase,0
		inc	dx
		in	al,dx
		test	al,S_PE
		jnz	gl_na
		inc	dx
		mov	al,00001111b	; power off
		out	dx,al
		ret
gl_np:		FPRIN  MessNoLpt, PortNum	; |[g
		$DOS  4ch,RC_ENV
gl_na:		FPRIN  MessNoAda, PortNum	; AVRXڑ
		$DOS  4ch,RC_ENV



send_reg:	; VtgWX^փf[^] (AH=send data)
		push	cx
		mov	dx,LptBase
		mov	al,PortReg
	_repeat 8
		res	al,B_SCMD+B_SCLK+B_SDAT
		rol	ah,1
	 @if c,<set	al,B_SDAT>
		out	dx,al
		set	al,B_SCLK
		out	dx,al
	_loop
		mov	PortReg,al
		pop	cx
		ret



read_data:	; AVRf[^ǂݍ (AH=read data)
		push	cx,bx
		mov	dx,LptBase
		mov	al,PortReg
		res	al,B_SCLK+B_SDAT+B_OE	; CLK,DAT,OE = L
		set	al,B_SCMD		; S1 = H
		out	dx,al			; /
		set	al,B_SCLK		; CLK = H
		out	dx,al			; /
		res	al,B_SCLK+B_SCMD	; CLK,S1 = L
		set	al,B_OE			; OE = H
		out	dx,al			; /
	_repeat 8
		shl	ah,1
		inc	dx
		mov	bl,al
		in	al,dx			; Read bit
		dec	dx
		test	al,S_ACK
	 @ifn z,<set	ah,BIT0>
		mov	al,bl
		res	al,B_SCLK+B_SCMD+B_SDAT	; CLK = L
		out	dx,al			; /
		set	al,B_SCLK		; CLK = H
		out	dx,al			; /
	_loop
		mov	PortReg,al
		pop	bx,cx
		ret



wr_pulse:	; WRpX
		outb	LptBase,PortReg
		res	al,B_WR		; WR = L
		out	dx,al		; /
		set	al,B_WR		; WR = H
		out	dx,al		; /
		ret

wr_pulse2:	; WRpX(>1ms)
		outb	LptBase,PortReg
		res	al,B_WR		; WR = L
		out	dx,al		; /
		DELAY	2		; Wait for 2ms
		set	al,B_WR		; WR = H
		out	dx,al		; /
		ret



wait_ready:	; RDY҂ (max 10ms)
		push	cx
		mov	dx,LptBase
		inc	dx
	_repeat 20000
		in	al,dx
		test	al,S_BUSY
	_loop nz
		pop	cx
		ret



xfer:		; VAf[^R}hM(dh=data,dl=cmd)
		push	ax,bx,cx
		mov	bx,dx
		clr	ax
	_repeat 8
		set	al,B_CLK	; CLK = H
		outp	LptBase,al	; /
		mov	al,0		; CMD,DAT = bit for send, CLK = L
		shl	bh,1		; 
	 @if c,<set	al,B_DAT>	; 
		rol	bl,1		; 
	 @if c,<set	al,B_CMD>	; 
		out	dx,al		; /
		inc	dx		; Read serial data
		mov	ah,al		; 
		in	al,dx		; 
		test	al,S_BUSY	; 
	 @if z,<set	bh,BIT0>	; 
		mov	al,ah		; /
	_loop
	_repeat 3			; Final three clocks
		set	al,B_CLK	; 
		outp	LptBase,al	; 
		mov	al,0		; 
		out	dx,al		; 
	_loop				; /
		mov	dx,bx		; dh = read data
		pop	cx,bx,ax
		ret



power_on:	; d ON
		outb	LptBase,0
		incw	dx
		mov	al,00001101b	; Vcc ON, RESET = L
		out	dx,al		; /
		DELAY	10
	_if e, Pin8, ON
	 _repeat 4			; Apply four clocks
		outb	LptBase,B_CLK	; 
		outb	LptBase,0	; 
	 _loop				; /
	_else
		outb	LptBase,B_WR+B_OE	; WR,OE = H
		mov	PortReg,al
	_endif
		incw	dx
		mov	al,00001100b	; RESET=12V
		out	dx,al		; /
		DELAY	2
		ret



power_off:	; d OFF
		cje	Pin8, ON, pwr_off8
		mov	dx,LptBase
		incw	dx
		mov	al,00001101b	; RESET = L
		out	dx,al		; /
		outb	LptBase,0	; Controls = L
		incw	dx
		mov	al,00001111b	; Vcc OFF
		out	dx,al		; /
		ret
pwr_off8:
		outb	LptBase,0	; Controls = L
		incw	dx
		mov	al,00001101b	; RESET = L
		out	dx,al		; /
		mov	al,00001111b	; Vcc OFF
		out	dx,al		; /
		ret



dly_ms:		; ax(ms) ҂(BIOSgp)
		inc	ax
		mov	dx,1000
		mul	dx
		mov	cx,dx
		mov	dx,ax
		$SYSTEM  86h
		ret



		$end	start

