.xlist
.sall
;********************************
;*				*
;*	cnrW`wb_	*
;*				*
;*	(C)ChaN, 1989		*
;*				*
;********************************

;------------------------------------------------------------------------------
;	ASCII control code definition

	NUL	equ	0
	SOH	equ	01h
	STX	equ	02h
	ETX	equ	03h
	EOT	equ	04h
	ENQ	equ	05h
	ACK	equ	06h
	BEL	equ	07h
	BS	equ	08h
	TAB	equ	09h
	LF	equ	0ah
	FF	equ	0ch
	CR	equ	0dh
	NAK	equ	15h
	CAN	equ	18h
	EOF	equ	1ah
	ESC	equ	1bh
	DEL	equ	7fh


;------------------------------------------------------------------------------
;	Bit operation

	BIT0	equ	0000000000000001b
	BIT1	equ	0000000000000010b
	BIT2	equ	0000000000000100b
	BIT3	equ	0000000000001000b
	BIT4	equ	0000000000010000b
	BIT5	equ	0000000000100000b
	BIT6	equ	0000000001000000b
	BIT7	equ	0000000010000000b
	BIT8	equ	0000000100000000b
	BIT9	equ	0000001000000000b
	BIT10	equ	0000010000000000b
	BIT11	equ	0000100000000000b
	BIT12	equ	0001000000000000b
	BIT13	equ	0010000000000000b
	BIT14	equ	0100000000000000b
	BIT15	equ	1000000000000000b


;------------------------------------------------------------------------------
;	Flag op.

	ON	equ	-1
	OFF	equ	0

;------------------------------------------------------------------------------
;	Stack op.

	push	equ	pushm		; OPTASM
	pop	equ	popm		; OPTASM

;------------------------------------------------------------------------------
;	Type

	bptr	equ	byte ptr
	wptr	equ	word ptr
	dwptr	equ	dword ptr
	ofs	equ	offset
	len	equ	length


;------------------------------------------------
;	PSP

DEF_PSP		macro
		org	0
 		db	10 dup(?)	; old parameters
 PspInt22	dd	?		; termination address
 PspInt23	dd	?		; control-Break hander address
 PspInt24	dd	?		; critical error handler address
 PspPpsp	dw	?		; parent PSP segment
 PspJft		db	20 dup(?)	; default Job File Table
 PspEnv		dw	?		; envilonment segment
 		dd	?		; SS:SP on entry to last INT 21h
 PspJftNum	dw	?		; number of entries in JFT
 PspJftPtr	dd	?		; pointer to JFT
		dd	?		; pointer to previos PSP
		db	4 dup(?)	; unused
 PspVer		db	?,?		; version number (to return on function 30h)
		db	14 dup(?)	; unused
		db	3 dup(?)	; INT21h/retf code
		db	9 dup(?)	; unused
 PspFcb1	db	16 dup(?)	; 1st FCB (filled by 1st commnad line argument)
 PspFcb2	db	16 dup(?)	; 2nd FCB (filled by 2nd commnad line argument)
		db	4 dup(?)	; unused
 PspDta		db	128 dup(?)	; command line / default DTA
		endm




;**********************************************
;	W}N
;**********************************************

$DOS	macro	func,par		;; cnrt@NV
    IFNB <par>
	mov	ax,(func SHL 8)+(par AND 0ffh)
    ELSE
	mov	ah,func
    ENDIF
	int	21h
	endm

$EMM	macro	func,par		;; dllt@NV
    IFNB <par>
	mov	ax,(func shl 8)+(par and 0ffh)
    ELSE
	mov	ah,func
    ENDIF
	int	67h
	endm


movseg	macro	dst,src		;; ZOg]
	push	src
	pop	dst
	endm

sds	macro	dst,src		;; far ߲]
	mov	wptr dst[0],src
	mov	wptr dst[2],ds
	endm

ses	macro	dst,src
	mov	wptr dst[0],src
	mov	wptr dst[2],es
	endm

inp	macro	reg,port	;; |[go
	mov	dx,port
	in	reg,dx
	endm

outp	macro	port,reg	;; |[g
	mov	dx,port
	out	dx,reg
	endm

inb	macro	dest,port	;; input byte
    IF (((.type port) and 14) ne 0)
	inp	al,port
    ELSE
     IF	port ge 100h
	inp	al,port
     ELSE
	in	al,port
     ENDIF
    ENDIF
	mov	dest,al
	endm

outb	macro	port,src	;; output byte
	mov	al,src
    IF (((.type port) and 14) ne 0)
	outp	port,al
    ELSE
     IF	port ge 100h
	outp	port,al
     ELSE
	out	port,al
     ENDIF
    ENDIF
	endm

inw	macro	dest,port	;; input word
    IF	port ge 100h
	inp	ax,port
    ELSE
	in	ax,port
    ENDIF
	mov	dest,ax
	endm

outw	macro	port,src	;; output word
	mov	ax,src
    IF	port ge 100h
	outp	port,ax
    ELSE
	out	port,ax
    ENDIF
	endm


set	macro	dest,bt		;; ޯľ or ׸޾
    IFNB <bt>
	or	dest,bt
    ELSE
	mov	dest,ON
    ENDIF
	endm
	
res	macro	dest,bt		;; ޯؾ or ׸ؾ
    IFNB <bt>
	and	dest,not bt
    ELSE
	mov	dest,OFF
    ENDIF
	endm

cpl	macro	dest,bt		;; ޯĺ or ׸޺
    IFNB <bt>
	xor	dest,bt
    ELSE
	not	dest
    ENDIF
	endm

tst	macro	dest		;; value 
	cmp	dest,0
	endm

clr	macro	r1,r2,r3	;; ڼ޽ر
	xor	r1,r1
    IFNB <r2>
	xor	r2,r2
    ENDIF
    IFNB <r3>
	xor	r3,r3
    ENDIF
	endm

setpb	macro	port,dat	;; I/O port logical op.
    IF port ge 100h
	inp	al,port
	set	al,dat
	out	dx,al
    ELSE
	in	al,port
	set	al,dat
	out	port,al
    ENDIF
	endm

respb	macro	port,dat	;; I/O port logical op.
    IF port ge 100h
	inp	al,port
	res	al,dat
	out	dx,al
    ELSE
	in	al,port
	res	al,dat
	out	port,al
    ENDIF
	endm

tstpb	macro	port,dat	;; I/O port bit test
    IF (((.type port) and 14) ne 0)
	inp	al,port
    ELSE
     IF	port ge 100h
	inp	al,port
     ELSE
	in	al,port
     ENDIF
    ENDIF
	test	al,dat
	endm

incw	macro	d1		;; increment word
    	inc	d1
    	inc	d1
	endm

decw	macro	d1		;; decrement word
    	dec	d1
    	dec	d1
	endm

addi	macro	dst,src1,src2	;; add and move
	mov	dst,src1
	add	dst,src2
	endm

subi	macro	dst,src1,src2	;; subtract and move
	mov	dst,src1
	sub	dst,src2
	endm

andi	macro	dst,src1,src2	;; add and move
	mov	dst,src1
	and	dst,src2
	endm

ori	macro	dst,src1,src2	;; subtract and move
	mov	dst,src1
	or	dst,src2
	endm



$ret	equ	ret			;; OPTASM
ret	equ	_ret			;; OPTASM
retn	equ	_retn			;; OPTASM

_ret	macro	cc,dst,src		;; ^  OPTASM
	local	l
  IFNB	<cc>
   IFNB  <dst>
	cmp	dst,src
   ENDIF
	jn&cc	l
	$ret
l:
  ELSE
	$ret
  ENDIF
	endm

_retn	macro	cc,dst,src		;;   OPTASM
	local	l
  IFNB  <dst>
	cmp	dst,src
  ENDIF
	j&cc	l
	$ret
l:
	endm

cje	macro	src1,src2,lbl
	cmp	src1,src2
	je	lbl
	endm

cjne	macro	src1,src2,lbl
	cmp	src1,src2
	jne	lbl
	endm

cja	macro	src1,src2,lbl
	cmp	src1,src2
	ja	lbl
	endm

cjb	macro	src1,src2,lbl
	cmp	src1,src2
	jb	lbl
	endm

cjae	macro	src1,src2,lbl
	cmp	src1,src2
	jae	lbl
	endm

cjbe	macro	src1,src2,lbl
	cmp	src1,src2
	jbe	lbl
	endm

cjna	macro	src1,src2,lbl
	cmp	src1,src2
	jna	lbl
	endm

cjnb	macro	src1,src2,lbl
	cmp	src1,src2
	jnb	lbl
	endm

cjnae	macro	src1,src2,lbl
	cmp	src1,src2
	jnae	lbl
	endm

cjnbe	macro	src1,src2,lbl
	cmp	src1,src2
	jnbe	lbl
	endm


;************************************************
;	\}N
;************************************************

	irpc	n,0123456789		;; Ƃ肠WKw܂ŃlXg
	$LP&n	= 0
	endm

	$LNUM	= 0
	$NEST	= 0

	$CASEB	= 10			;; case block p
	$CASEN	= 0
	$INCASE	= OFF


$rcb	macro	cc,c1,c2		;; tWv (BLOCK)
  IFIDN <cc>,<c1>
	$jcc	c2,%$NEST,%$LNUM
  ENDIF
  IFIDN <cc>,<c2>
	$jcc	c1,%$NEST,%$LNUM
  ENDIF
	endm


_if	macro	cc,dst,src		;; ubNJn
	$enter	%$NEST,%($NEST+1)	;; cc ubNs
	$LNUM	= $LNUM+1
  IFNB <src>
	cmp	dst,src
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
  IRP ccc,<<c,nc>,<e,ne>,<z,nz>,<b,nb>,<a,na>,<g,ng>,<l,nl>,<be,nbe>,<ae,nae>,<ge,nge>,<le,nle>,<s,ns>,<cxz,ncxz>>
	$rcb	cc,ccc
  ENDM
	endm

_skip	macro	cc,dst,src		;; XLbv
	$enter	%$NEST,%($NEST+1)	;; cc 𗪂ƖXLbv
	$LNUM	= $LNUM+1
  IFNB <src>
	cmp	dst,src
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	cc,%$NEST,%$LNUM
	endm

@if	macro	cc,inst			;; PƖ߁iPj
	local	l1
	jn&cc	l1
	inst
l1:
	endm

@ifn	macro	cc,inst			;; PƖ߁iQj
	local	l1
	j&cc	l1
	inst
l1:
	endm

_else	macro				;; t̏ꍇs
	$jcc	<>,%$NEST,%($LNUM+1)
	$label	%$NEST,%$LNUM
	$LNUM	= $LNUM+1
	endm

_endif	macro				;; ubN̏I[
	$label	%$NEST,%$LNUM
	$leave	%$NEST,%($NEST-1)
	endm

__endif	macro				;; ubN̏I[iQAj
	_endif
	_endif
	endm

___endif macro				;; ubN̏I[iRAj
	_endif
	_endif
	_endif
	endm

____endif macro				;; ubN̏I[iSAj
	_endif
	_endif
	_endif
	_endif
	endm


_repeat	macro	count, dst,src		;; REPEAT [v̊Jni擪j
	$enter	%$NEST,%($NEST+1)	;; count ݒ肷 cx ɒl۰
  IFNB	<count>
   IFB <dst>
	mov	cx,count
   ENDIF
  ENDIF
	$LNUM	= $LNUM+1
	$label	%$NEST,%$LNUM
  IFNB <dst>
   IFNB <src>
	cmp	dst,src
   ELSE
 	dst
   ENDIF
	$LNUM	= $LNUM+1
   IRP ccc,<<c,nc>,<e,ne>,<z,nz>,<b,nb>,<a,na>,<g,ng>,<l,nl>,<be,nbe>,<ae,nae>,<ge,nge>,<le,nle>,<s,ns>,<cxz,ncxz>>
	$rcb	count,ccc
   ENDM
	$LNUM	= $LNUM-1
  ENDIF
	endm


_while	equ	_repeat			;; _repeat Ɠ


_break	macro	cc,dst,src		;; cc ꍇA
  IFNB <src>				;; REPEAT [v𔲂
	cmp	dst,src
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	cc,%$NEST,%($LNUM+1)
	endm

_cont	macro	cc,dst,src		;; cc ꍇA
  IFNB <src>				;; REPEAT [v̐擪ĊJ
	cmp	dst,src
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	cc,%$NEST,%$LNUM
	endm

_rept	macro	cc,dst,src		;; REPEAT [v̏I[
  IFNB <src>				;; cc ԁA擪Ƃ̊ԂJԂ
	cmp	dst,src			;; cc 𗪂Əɐ
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$jcc	cc,%$NEST,%$LNUM
	$LNUM	= $LNUM+1
	$label	%$NEST,%$LNUM
	$leave	%$NEST,%($NEST-1)
	endm

_loop	macro	cc,dst,src		;; REPEAT [v̏I[
  IFNB <src>				;; 擪Ƃ̊Ԃ loop s
	cmp	dst,src			;; cc ȗ
  ELSE
   IFNB <dst>
	dst
   ENDIF
  ENDIF
	$loop	cc,%$NEST,%$LNUM
	$LNUM	= $LNUM+1
	$label	%$NEST,%$LNUM
	$leave	%$NEST,%($NEST-1)
	endm




$rcc	macro	cc,c1,c2		;; tWv (CASE)
  IFIDN <cc>,<c1>
	$cjcc	c2,%$CASEB,%$CASEN
  ENDIF
  IFIDN <cc>,<c2>
	$cjcc	c1,%$CASEB,%$CASEN
  ENDIF
	endm


_case	macro	cc,dst,src		;; P[XubN
  IF $INCASE ne ON
	$INCASE = ON
	$CASEN = 0
  ELSE
	$cjcc	<>,%$CASEB,T
  ENDIF
	$labc	%$CASEB,%$CASEN
	$CASEN = $CASEN+1
  IFNB <src>
	cmp	dst,src
  ELSE
	dst
  ENDIF
  IRP ccc,<<c,nc>,<e,ne>,<z,nz>,<b,nb>,<a,na>,<g,ng>,<l,nl>,<be,nbe>,<ae,nae>,<ge,nge>,<le,nle>,<s,ns>,<cxz,ncxz>>
	$rcc	cc,ccc
  ENDM
	endm

_default macro
	$cjcc	<>,%$CASEB,T
	$labc	%$CASEB,%$CASEN
	$CASEN = $CASEN+1
	endm

_endc	macro
	$labc	%$CASEB,%$CASEN
	$labc	%$CASEB,T
	$CASEB	= $CASEB+1
	$INCASE = OFF
	endm




$enter	macro	a,b			;; lXgEC
  IF	$NEST ge 8			;; 
	%out	* Nesting Over! *
  ENDIF
	$LP&a	= $LNUM
	$LNUM	= $LP&b
	$NEST	= $NEST+1
	endm

$leave	macro	a,b			;; lXgEAEg
  IF	$NEST  eq 0
	%out	* Nesting Over! *
  ENDIF
	$LP&a	= $LNUM
	$LNUM	= $LP&b
	$NEST	= $NEST-1
	endm

$label	macro	l,m			;; BLOCK x̐
$&l&m:
	endm

$labc	macro	l,m			;; CASE x̐
$C&l&m:
	endm



$jcc	macro	cc,l,m			;; Wv̐
  IFNB <cc>
	j&cc	$&l&m
  ELSE
	jmp	$&l&m
  ENDIF
	endm

$cjcc	macro	cc,l,m			;; Wv̐
  IFNB <cc>
	j&cc	$C&l&m
  ELSE
	jmp	$C&l&m
  ENDIF
	endm

$jncc	macro	cc,l,m			;; Wv̐
	jn&cc	$&l&m
	endm


$loop	macro	cc,l,m			;; LOOP߂̐
	loop&cc $&l&m
	endm


$end	macro	l			;; vOI[
    IF	$NEST ne 0
	%out	*** Block Macro Open Nest ***
    ENDIF
	end	l
	endm


;*****************
;** END OF FILE **
;*****************
.list
